/* Generated by re2c 0.9.11.rc1 on Tue Nov 22 00:13:36 2005 */
#line 1 "ext/docblock/docblock_scan.re"
/*
   +----------------------------------------------------------------------+
   | DocBlock Scanner                                                     |
   +----------------------------------------------------------------------+
   | Copyright (c) 2005 Gregory Beaver                                    |
   +----------------------------------------------------------------------+
   | This source file is subject to version 3.00 of the PHP license,      |
   | that is bundled with this package in the file LICENSE, and is        |
   | available through the world-wide-web at the following url:           |
   | http://www.php.net/license/3_00.txt.                                 |
   | If you did not receive a copy of the PHP license and are unable to   |
   | obtain it through the world-wide-web, please send a note to          |
   | license@php.net so we can mail you a copy immediately.               |
   +----------------------------------------------------------------------+
   | Authors: Gregory Beaver <cellog@php.net>                             |
   +----------------------------------------------------------------------+
*/

/* $Id: docblock_scan.c,v 1.14 2005/11/22 06:16:03 cellog Exp $ */

#include "zend_API.h"
#include "zend.h"
#include "docblock_scan.h"

//#define DOCBLOCK_DEBUG

/* re2c defines */
/* refill buffer - unused */
#define YYFILL(n)
/* character type */
#define YYCTYPE char
#define	YYCURSOR cursor
#define YYLIMIT s->length
#define YYMARKER s->ptr

#define DOCB_STATE(z) DOCBLOCK_SCAN_##z

#define DOCB_RET(t,z)\
	if (s->return_simplelist_end) {\
		cursor = s->token;\
		s->current_token = (char *)emalloc(cursor - s->token + 1);\
		s->current_token[0] = '\0';\
		s->return_simplelist_end = 0;\
		return DOCB_SIMPLELISTEND;\
	}\
	if (s->normalcursor) {\
		if (t == DOCB_SIMPLELISTEND) {\
			s->return_simplelist_end = 1;\
		} else {\
			s->return_simplelist_end = 0;\
		}\
		cursor = s->token;\
		s->token = s->normalcursor;\
		s->cursor = cursor;\
		s->current_token = (char *)emalloc(cursor - s->token + 1);\
		memcpy(s->current_token,s->token,cursor - s->token);\
		*(s->current_token + (cursor - s->token)) = '\0';\
		s->token = cursor;\
		s->normalcursor = 0;\
		return s->normaltoken;\
	}\
	s->cursor = cursor;\
	s->current_token = (char *)emalloc(cursor - s->token + 1);\
	memcpy(s->current_token,s->token,cursor - s->token);\
	*(s->current_token + (cursor - s->token)) = '\0';\
	s->token = cursor;\
	s->state = DOCB_STATE(z);\
	return t;

#define DOCB_BEGIN(z) s->cursor = cursor;s->token = cursor;s->state = DOCB_STATE(z);goto z;
#define DOCB_BEGINT(tok,state)\
	if (!s->normalcursor) {\
		s->normalcursor = s->token;\
		s->normaltoken = tok;\
	}\
	DOCB_BEGIN(state)


// switch to proper error handling when the time is right
#define DOCB_ERROR(m) zend_printf(m);return -1;
#ifdef DOCBLOCK_DEBUG
#define DOCB_DB(message) tmp = (char *)emalloc(cursor - s->token + 1);\
	memcpy(tmp,s->token,cursor - s->token);\
	*(tmp + (cursor - s->token)) = '\0';\
	zend_printf(#message" (%.*s)\n", cursor - s->token, tmp);\
	efree(tmp);
#else
#define DOCB_DB(message)
#endif

#define DOCBLOCK_SCAN_START 1
#define DOCBLOCK_SCAN_LINESTART 2
#define DOCBLOCK_SCAN_PREASTERISK 3
#define DOCBLOCK_SCAN_POSTASTERISK 4
#define DOCBLOCK_SCAN_IGNOREDLINE 5
#define DOCBLOCK_SCAN_NORMAL 6
#define DOCBLOCK_SCAN_INTERNAL 7
#define DOCBLOCK_SCAN_INLINETAG 8
#define DOCBLOCK_SCAN_CODE 9
#define DOCBLOCK_SCAN_PRE 10
#define DOCBLOCK_SCAN_SIMPLELIST 11

typedef struct _docblock_simplelist {
	char	token[3];
	char	*whitespace;
} docblock_simplelist;

static docblock_simplelist *_docblock_new_item(docblock_Scanner *s,
					   const char *token,
					   const char *cursor, char *ptr)
{
	docblock_simplelist *listitem;
	listitem = (docblock_simplelist *) emalloc(sizeof (docblock_simplelist));
	// note the whitespace
	listitem->whitespace = (char *) emalloc(ptr - token + 1);
	memcpy(listitem->whitespace, token, ptr - token);
	*(listitem->whitespace + (ptr - token)) = '\0';
	if (*ptr >= '1' && *ptr <= '9') {
		if (*(ptr + 1) == '.') {
			listitem->token[1] = '.';
		} else {
			listitem->token[1] = '\0';
		}
		listitem->token[0] = *ptr;
	} else {
		listitem->token[0] = *ptr;
		listitem->token[1] = '\0';
	}
	return listitem;
}

static void _docblock_simplelist_dtor(void *el)
{
//	*((docblock_simplelist *) el)->whitespace = '\0';
//	efree(((docblock_simplelist *) el)->whitespace);
}

static int _docblock_detect_new_simplelist(docblock_Scanner *s,
					   const char *token,
					   const char *cursor)
{
	int test, expt, need_dot, i;
	char *tmp, *ptr, expected_token[3];
	docblock_simplelist *testitem, *newitem;
	// 1 = start new list, -1 = end list, 0 = error, 2 = carry on
	// 3 = next list item
	need_dot = 0;
	expt = 0;
	test = 0;
	i = 0;
	tmp = (char *)emalloc(cursor - token + 1);
	memcpy(tmp, token, cursor - token);
	*(tmp + (cursor - token)) = '\0';
	ptr = tmp;
	expected_token[0] = '\0';
	expected_token[1] = '\0';
	expected_token[2] = '\0';
	while ((*ptr == ' ' || *ptr == '\t') && *ptr != '\0') ++ptr;

	if (*ptr == '\0') {
		// error
		efree(tmp);
		return 0;
	}
	if (s->simplelist->count) {
		// construct the next token we need to see
		testitem = (docblock_simplelist *) s->simplelist->tail->data;
		// first, make sure the whitespace is identical.  If not, we
		// need to be looking for other lists
		if ((ptr - tmp) > strlen(testitem->whitespace)) {
			if ((ptr - tmp) >= strlen(testitem->whitespace) + 1) {
				goto LOOK_FOR_OTHER_LISTS;
			} else {
				efree(tmp);
				// a simple list has ended
				zend_llist_remove_tail(s->simplelist);
				return -1;
			}
		}
		if ((ptr - tmp) < strlen(testitem->whitespace)) {
			// no need to continue, this list is over
			efree(tmp);
			// a simple list has ended
			zend_llist_remove_tail(s->simplelist);
			return -1;
		}
		expected_token[0] = testitem->token[0];
		expected_token[1] = testitem->token[1];
		expected_token[2] = testitem->token[2];
		if (expected_token[0] >= '1' && expected_token[0] <= '9') {
			expt = (expected_token[0] - '1' + 1);
			if (expected_token[1] >= '1' && expected_token[1] <= '0') {
				if (expected_token[2] == '.') {
					need_dot = 1;
				}
				expt *= 10;
				expt += expected_token[1] - '1' + 1;
			} else {
				if (expected_token[1] == '.') {
					need_dot = 1;
				}
			}
			expt++;
			if (expt > 99) {
				// this is a ridiculous list - who needs 99+
				// simple list entries in a docblock??!
				zend_llist_remove_tail(s->simplelist);
				efree(tmp);
				// end this list
				return -1;
			}
			expected_token[1] = '\0';
			expected_token[2] = '\0';
			if (sprintf(expected_token, "%d", expt)) {
				if (need_dot) {
					if (expected_token[1] == '\0') {
						expected_token[1] = '.';
					} else {
						expected_token[2] = '.';
					}
				}
			}
		}
		// assume match
		test = 0;
		for (i = 0; i < 3; i++) {
			if (expected_token[i] == '\0') {
				break;
			}
			if (*(ptr + i) != expected_token[i]) {
				test = 1;
				break;
			}
		}
		if (!test) {
			// bullet must always be followed by whitespace to
			// be a simple list item
			if (*(ptr + i) != ' ' && *(ptr + i) != '\t') {
				test = 1;
			} else {
				// save the expected token for the next list item
				testitem->token[0] = expected_token[0];
				testitem->token[1] = expected_token[1];
				testitem->token[2] = expected_token[2];
			}
		}
	} else {
LOOK_FOR_OTHER_LISTS:
		testitem = 0;
		// test for tokens
		test = (*ptr != '*' && *ptr != '-' && *ptr != 'o' && *ptr != '+');
		i = 1;
		// test is set if no unordered bullets were found
		if (test) {
			test = (*ptr != '1');
			if (!test) {
				if (*(ptr + 1) == '.') i++;
			}
		}
		// a simplelist bullet was found
		if (!test) {
			// bullet must always be followed by whitespace to
			// be a simple list item
			if (*(ptr + i) != ' ' && *(ptr + i) != '\t') {
				test = 1;
			}
		}
	}
	// no simple list tokens were matched
	if (test) {
		// no new simplelist item
		if (testitem) {
			// we need whitespace like so:
			// - simplelist
			//   continued line
			// meaning we need 2 extra whitespace tokens
			if ((ptr - tmp) >= strlen(testitem->whitespace) + 2) {
				efree(tmp);
				// continue existing list item
				return 2;
			} else {
				// a simple list has ended
				zend_llist_remove_tail(s->simplelist);
				efree(tmp);
				return -1;
			}
		} else {
			// no simple list
			efree(tmp);
			// continue non-simple list text
			return 2;
		}
	} else {
		// simple list tokens matched
		if (testitem) {
			// we need identical whitespace like so:
			// - simplelist item 1
			// - simplelist item 2
			// otherwise we have a new list
			if ((ptr - tmp) > strlen(testitem->whitespace)) {
				newitem = _docblock_new_item(s, token, cursor,
					(char *) ((ptr - tmp) + token));
				zend_llist_add_element(s->simplelist, newitem);
				efree(tmp);
				_docblock_simplelist_dtor(newitem);
				// start nested list
				return 1;
			}
			if ((ptr - tmp) < strlen(testitem->whitespace)) {
				efree(tmp);
				zend_llist_remove_tail(s->simplelist);
				// finish this list
				return -1;
			}
			// continue with next list item
			efree(tmp);
			return 3;
		} else {
			// brand new list
			newitem = _docblock_new_item(s, token, cursor,
				(char *) ((ptr - tmp) + token));
			zend_llist_add_element(s->simplelist, newitem);
			efree(newitem);
			efree(tmp);
			return 1;
		}
	}
}

PHP_DOCBLOCK_API docblock_Scanner *docblock_prepare_string(char *input_str, int length TSRMLS_DC)
{
	docblock_Scanner *scan;
	scan = (docblock_Scanner *)emalloc(sizeof (docblock_Scanner));
	scan->buffer = (char *)emalloc(length + 1);
	memcpy(scan->buffer, input_str, length + 1);
	scan->token = scan->buffer;
	scan->cursor = scan->token;
	scan->ptr = scan->cursor;
	scan->length = scan->buffer + length;
	scan->line = 0;
	scan->state = DOCBLOCK_SCAN_START;
	scan->in_internal = 0;
	scan->in_inlinetag = 0;
	scan->return_simplelist_end = 0;
	scan->in_code = 0;
	scan->in_pre = 0;
	scan->current_token = 0;
	scan->normalcursor = 0;
	scan->normaltoken = 0;
	scan->simplelist = (zend_llist *)emalloc(sizeof (zend_llist));
	zend_llist_init(scan->simplelist, sizeof (docblock_simplelist), _docblock_simplelist_dtor, 0);
	return scan;
}

PHP_DOCBLOCK_API void docblock_finish_scan(docblock_Scanner *s TSRMLS_DC)
{
	if (s) {
		if (s->simplelist->count) {
			zend_llist_destroy(s->simplelist);
		}
		efree(s->simplelist);
		if (s->buffer) {
			efree(s->buffer);
		}
		efree(s);
	}
}

PHP_DOCBLOCK_API int docblock_scan(docblock_Scanner *s TSRMLS_DC)
{
	char *cursor,*tmp;

	s->current_token = 0;
	if (s->cursor >= s->length) {
		if (s->normalcursor) {
			// unreturned output
			// values are ignored, and the normalcursor will instead be returned
			DOCB_RET(0,IGNOREDLINE);
		}
		return 0;
	}
	cursor = s->cursor;
#line 392 "ext/docblock/docblock_scan.re"

#define DOCB_CASES(z) case DOCB_STATE(z):goto z;
	switch (s->state) {
		DOCB_CASES(START)
		DOCB_CASES(LINESTART)
		DOCB_CASES(PREASTERISK)
		DOCB_CASES(POSTASTERISK)
		DOCB_CASES(IGNOREDLINE)
		DOCB_CASES(NORMAL)
		DOCB_CASES(CODE)
		DOCB_CASES(PRE)
		DOCB_CASES(INLINETAG)
		DOCB_CASES(SIMPLELIST)
	}
#undef DOCB_CASES
START:
{

#line 405 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy0;
	++YYCURSOR;
yy0:
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if(yych == 0x0A)	goto yy2;
	if(yych == '/')	goto yy3;
	goto yy5;
yy2:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 1:	goto yy8;
	case 0:	goto yy4;
	}
yy3:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '*')	goto yy6;
	goto yy4;
yy4:
#line 420 "ext/docblock/docblock_scan.re"
{ DOCB_DB("SKIP");
	  --cursor;
	  DOCB_BEGIN(LINESTART);
	}
#line 432 "ext/docblock/docblock_scan.c"
yy5:	yych = *++YYCURSOR;
	goto yy4;
yy6:	yych = *++YYCURSOR;
	if(yych != '*')	goto yy2;
	goto yy7;
yy7:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '#')	goto yy9;
	goto yy8;
yy8:
#line 417 "ext/docblock/docblock_scan.re"
{ DOCB_DB("start comment")
	  DOCB_RET(DOCB_COMMENTSTART,POSTASTERISK);
	}
#line 447 "ext/docblock/docblock_scan.c"
yy9:	yych = *++YYCURSOR;
	if(yych != '@')	goto yy2;
	goto yy10;
yy10:	yych = *++YYCURSOR;
	if(yych == '+')	goto yy11;
	if(yych == '-')	goto yy13;
	goto yy2;
yy11:	++YYCURSOR;
	goto yy12;
yy12:
#line 414 "ext/docblock/docblock_scan.re"
{ DOCB_DB("start comment template")
	  DOCB_RET(DOCB_COMMENTTEMPLATE,POSTASTERISK);
	}
#line 462 "ext/docblock/docblock_scan.c"
yy13:	yych = *++YYCURSOR;
	if(yych != '*')	goto yy2;
	goto yy14;
yy14:	yych = *++YYCURSOR;
	if(yych != '/')	goto yy2;
	goto yy15;
yy15:	++YYCURSOR;
	goto yy16;
yy16:
#line 410 "ext/docblock/docblock_scan.re"
{ DOCB_DB("start comment template")
	  DOCB_RET(DOCB_COMMENTTEMPLATEEND,POSTASTERISK);
	}
#line 476 "ext/docblock/docblock_scan.c"
}
}
#line 425 "ext/docblock/docblock_scan.re"

LINESTART:
{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 128,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	};

#line 518 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	goto yy17;
	++YYCURSOR;
yy17:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy24;
	}
	if(yych <= 0x0C){
		if(yych == 0x0A)	goto yy21;
		goto yy27;
	} else {
		if(yych <= 0x0D)	goto yy23;
		if(yych != '*')	goto yy27;
		goto yy19;
	}
yy19:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy29;
	goto yy20;
yy20:
#line 449 "ext/docblock/docblock_scan.re"
{ DOCB_DB("asterisk")
	  DOCB_RET(DOCB_ASTERISK,POSTASTERISK);
	}
#line 545 "ext/docblock/docblock_scan.c"
yy21:	++YYCURSOR;
	goto yy22;
yy22:
#line 442 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (LINESTART)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 553 "ext/docblock/docblock_scan.c"
yy23:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy21;
	goto yy22;
yy24:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy25;
yy25:	if(yybm[0+yych] & 128) {
		goto yy24;
	}
	goto yy26;
yy26:
#line 446 "ext/docblock/docblock_scan.re"
{ DOCB_DB("pre-asterisk whitespace")
	  DOCB_RET(DOCB_WHITESPACE,PREASTERISK);
	}
#line 570 "ext/docblock/docblock_scan.c"
yy27:	++YYCURSOR;
	goto yy28;
yy28:
#line 453 "ext/docblock/docblock_scan.re"
{ DOCB_DB("SKIP")
	  --cursor;
	  DOCB_BEGIN(IGNOREDLINE);
	}
#line 579 "ext/docblock/docblock_scan.c"
yy29:	++YYCURSOR;
	goto yy30;
yy30:
#line 428 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			// don't cut out multiple list end tokens
			// when we need to
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end 1")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 597 "ext/docblock/docblock_scan.c"
}
}
#line 457 "ext/docblock/docblock_scan.re"

IGNOREDLINE:
{
	static unsigned char yybm[] = {
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0, 128, 128,   0, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 639 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	goto yy31;
	++YYCURSOR;
yy31:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy38;
	}
	if(yych <= 0x0C)	goto yy35;
	if(yych <= 0x0D)	goto yy37;
	goto yy33;
yy33:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy41;
	goto yy34;
yy34:
#line 480 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ignored line")
	  DOCB_BEGINT(DOCB_IGNOREDLINE,IGNOREDLINE);
	}
#line 661 "ext/docblock/docblock_scan.c"
yy35:	++YYCURSOR;
	goto yy36;
yy36:
#line 472 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (IGNOREDLINE)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 669 "ext/docblock/docblock_scan.c"
yy37:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy35;
	goto yy36;
yy38:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy39;
yy39:	if(yybm[0+yych] & 128) {
		goto yy38;
	}
	goto yy40;
yy40:
#line 476 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ignored line")
	  DOCB_BEGINT(DOCB_IGNOREDLINE,IGNOREDLINE);
	}
#line 686 "ext/docblock/docblock_scan.c"
yy41:	++YYCURSOR;
	goto yy42;
yy42:
#line 460 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end 2")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 702 "ext/docblock/docblock_scan.c"
}
}
#line 483 "ext/docblock/docblock_scan.re"

PREASTERISK:
{

#line 710 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	goto yy43;
	++YYCURSOR;
yy43:
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if(yych <= 0x0C){
		if(yych == 0x0A)	goto yy47;
		goto yy50;
	} else {
		if(yych <= 0x0D)	goto yy49;
		if(yych != '*')	goto yy50;
		goto yy45;
	}
yy45:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy52;
	goto yy46;
yy46:
#line 501 "ext/docblock/docblock_scan.re"
{ DOCB_DB("asterisk")
	  DOCB_RET(DOCB_ASTERISK,POSTASTERISK);
	}
#line 734 "ext/docblock/docblock_scan.c"
yy47:	++YYCURSOR;
	goto yy48;
yy48:
#line 498 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (PREASTERISK)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 742 "ext/docblock/docblock_scan.c"
yy49:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy47;
	goto yy48;
yy50:	++YYCURSOR;
	goto yy51;
yy51:
#line 505 "ext/docblock/docblock_scan.re"
{ DOCB_DB("SKIP")
	  --cursor;
	  DOCB_BEGIN(IGNOREDLINE);
	}
#line 754 "ext/docblock/docblock_scan.c"
yy52:	++YYCURSOR;
	goto yy53;
yy53:
#line 486 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 770 "ext/docblock/docblock_scan.c"
}
}
#line 509 "ext/docblock/docblock_scan.re"

POSTASTERISK:
	if (s->in_inlinetag) {
		goto INLINETAG;
	}
	if (s->in_code) {
		goto CODE;
	}
	if (s->in_pre) {
		goto PRE;
	}
	goto NOTSIMPLELIST;
SIMPLELIST:
{
	static unsigned char yybm[] = {
	128, 128, 128, 128, 128, 128, 128, 128, 
	128,   0, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	  0, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 823 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	goto yy54;
	++YYCURSOR;
yy54:
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 128) {
		goto yy57;
	}
	goto yy56;
yy56:yy57:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy58;
yy58:	if(yybm[0+yych] & 128) {
		goto yy57;
	}
	goto yy59;
yy59:
#line 523 "ext/docblock/docblock_scan.re"
{ DOCB_DB("simple list bullet");
	  DOCB_RET(DOCB_SIMPLELISTBULLET,NORMAL);
	}
#line 848 "ext/docblock/docblock_scan.c"
}
}
#line 526 "ext/docblock/docblock_scan.re"

NOTSIMPLELIST:
	if (!s->in_internal) {
{
	static unsigned char yybm[] = {
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0, 128,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	128,   0,   0,   0,   0,   0,   0,   0, 
	  0,   0,   0,   0,   0,   0,   0,   0, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,   0,   0,   0,   0,   0,   0, 
	  0,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,   0,   0,   0,   0,  64, 
	  0,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,   0,   0,   0,   0,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	};

#line 891 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy60;
	++YYCURSOR;
yy60:
	if((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if(yych <= 0x1F){
		if(yych <= 0x0A){
			if(yych <= 0x08)	goto yy69;
			if(yych <= 0x09)	goto yy64;
			goto yy66;
		} else {
			if(yych == 0x0D)	goto yy68;
			goto yy69;
		}
	} else {
		if(yych <= '*'){
			if(yych <= ' ')	goto yy64;
			if(yych <= ')')	goto yy69;
			goto yy62;
		} else {
			if(yych == '@')	goto yy65;
			goto yy69;
		}
	}
yy62:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy95;
	goto yy63;
yy63:
#line 626 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end (.)")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("SKIP")
	  --cursor;
	  DOCB_BEGIN(NORMAL);
	}
#line 936 "ext/docblock/docblock_scan.c"
yy64:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy63;
	goto yy80;
yy65:	yych = *++YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy63;
		if(yych <= 'Z')	goto yy70;
		if(yych <= '^')	goto yy63;
		goto yy70;
	} else {
		if(yych <= '`')	goto yy63;
		if(yych <= 'z')	goto yy70;
		if(yych <= '~')	goto yy63;
		goto yy70;
	}
yy66:	++YYCURSOR;
	goto yy67;
yy67:
#line 615 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end (\\n)")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("newline (POSTASTERISK)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 967 "ext/docblock/docblock_scan.c"
yy68:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy66;
	goto yy67;
yy69:	yych = *++YYCURSOR;
	goto yy63;
yy70:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy71;
yy71:	if(yybm[0+yych] & 64) {
		goto yy70;
	}
	if(yych == '.')	goto yy73;
	goto yy72;
yy72:
#line 579 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end (tag)")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("tag")
	  DOCB_RET(DOCB_TAG,NORMAL);
	}
#line 996 "ext/docblock/docblock_scan.c"
yy73:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy74;
		if(yych <= 'Z')	goto yy75;
		if(yych >= '_')	goto yy75;
		goto yy74;
	} else {
		if(yych <= '`')	goto yy74;
		if(yych <= 'z')	goto yy75;
		if(yych >= 0x7F)	goto yy75;
		goto yy74;
	}
yy74:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 2:	goto yy86;
	case 0:	goto yy72;
	case 1:	goto yy78;
	}
yy75:	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy76;
yy76:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy73;
			goto yy72;
		} else {
			if(yych <= '9')	goto yy75;
			if(yych <= '@')	goto yy72;
			goto yy75;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy75;
			goto yy72;
		} else {
			if(yych <= 'z')	goto yy75;
			if(yych <= '~')	goto yy72;
			goto yy75;
		}
	}
yy77:	++YYCURSOR;
	goto yy78;
yy78:
#line 591 "ext/docblock/docblock_scan.re"
{ switch (_docblock_detect_new_simplelist(s, s->token, cursor)) {
		case -1 : // end list
			cursor = s->token;
			DOCB_DB("simple list end")
	  		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
		case 3 : // next list item
			cursor = s->token + strlen(
			  ((docblock_simplelist *)s->simplelist->tail->data)->whitespace);
			DOCB_DB("simple list item whitespace")
			DOCB_RET(DOCB_WHITESPACE,SIMPLELIST);
		case 1 : // start new list
			cursor = s->token + strlen(
			  ((docblock_simplelist *)s->simplelist->tail->data)->whitespace);
			DOCB_DB("simple list start whitespace")
			DOCB_RET(DOCB_SIMPLELISTSTART,SIMPLELIST);
		case 0 : // error
		case 2 : // carry on as you were
			cursor = s->token;
			while (*cursor == ' ' || *cursor == '\t') cursor++;
			DOCB_DB("pre-content whitespace (spaces .)")
			DOCB_RET(DOCB_WHITESPACE,NORMAL)
	  }
	}
#line 1068 "ext/docblock/docblock_scan.c"
yy79:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
	goto yy80;
yy80:	if(yybm[0+yych] & 128) {
		goto yy79;
	}
	if(yych <= '-'){
		if(yych <= ')'){
			if(yych == 0x0A)	goto yy78;
			goto yy77;
		} else {
			if(yych == ',')	goto yy77;
			goto yy81;
		}
	} else {
		if(yych <= '?'){
			if(yych <= '0')	goto yy77;
			if(yych <= '9')	goto yy82;
			goto yy77;
		} else {
			if(yych <= '@')	goto yy83;
			if(yych != 'o')	goto yy77;
			goto yy81;
		}
	}
yy81:	yych = *++YYCURSOR;
	if(yych == 0x09)	goto yy92;
	if(yych == ' ')	goto yy92;
	goto yy78;
yy82:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych <= ' '){
		if(yych == 0x09)	goto yy92;
		if(yych <= 0x1F)	goto yy78;
		goto yy92;
	} else {
		if(yych <= '.'){
			if(yych <= '-')	goto yy78;
			goto yy91;
		} else {
			if(yych <= '/')	goto yy78;
			if(yych <= '9')	goto yy90;
			goto yy78;
		}
	}
yy83:	yych = *++YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy78;
		if(yych <= 'Z')	goto yy84;
		if(yych <= '^')	goto yy78;
		goto yy84;
	} else {
		if(yych <= '`')	goto yy78;
		if(yych <= 'z')	goto yy84;
		if(yych <= '~')	goto yy78;
		goto yy84;
	}
yy84:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy85;
yy85:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy87;
			goto yy86;
		} else {
			if(yych <= '9')	goto yy84;
			if(yych >= 'A')	goto yy84;
			goto yy86;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy84;
			goto yy86;
		} else {
			if(yych <= 'z')	goto yy84;
			if(yych >= 0x7F)	goto yy84;
			goto yy86;
		}
	}
yy86:
#line 566 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end (pre-tag)")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  cursor = s->token;
	  while (*cursor == ' ' || *cursor == '\t') cursor++;
	  DOCB_DB("pre-content whitespace (pre-tag)")
	  DOCB_RET(DOCB_WHITESPACE,POSTASTERISK);
	}
#line 1166 "ext/docblock/docblock_scan.c"
yy87:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy74;
		if(yych <= 'Z')	goto yy88;
		if(yych <= '^')	goto yy74;
		goto yy88;
	} else {
		if(yych <= '`')	goto yy74;
		if(yych <= 'z')	goto yy88;
		if(yych <= '~')	goto yy74;
		goto yy88;
	}
yy88:	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy89;
yy89:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy87;
			goto yy86;
		} else {
			if(yych <= '9')	goto yy88;
			if(yych <= '@')	goto yy86;
			goto yy88;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy88;
			goto yy86;
		} else {
			if(yych <= 'z')	goto yy88;
			if(yych <= '~')	goto yy86;
			goto yy88;
		}
	}
yy90:	yych = *++YYCURSOR;
	if(yych <= 0x1F){
		if(yych == 0x09)	goto yy92;
		goto yy74;
	} else {
		if(yych <= ' ')	goto yy92;
		if(yych != '.')	goto yy74;
		goto yy91;
	}
yy91:	yych = *++YYCURSOR;
	if(yych == 0x09)	goto yy92;
	if(yych != ' ')	goto yy74;
	goto yy92;
yy92:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy93;
yy93:	if(yych == 0x09)	goto yy92;
	if(yych == ' ')	goto yy92;
	goto yy94;
yy94:
#line 542 "ext/docblock/docblock_scan.re"
{ switch (_docblock_detect_new_simplelist(s, s->token, cursor)) {
		case -1 : // end list
			cursor = s->token;
			DOCB_DB("simple list end")
	  		DOCB_RET(DOCB_SIMPLELISTEND,NORMAL);
		case 3 : // next list item
			cursor = s->token + strlen(
			  ((docblock_simplelist *)s->simplelist->tail->data)->whitespace);
			DOCB_DB("simple list item whitespace")
			DOCB_RET(DOCB_WHITESPACE,SIMPLELIST);
		case 1 : // start new list
			cursor = s->token + strlen(
			  ((docblock_simplelist *)s->simplelist->tail->data)->whitespace);
			DOCB_DB("simple list start whitespace")
			DOCB_RET(DOCB_SIMPLELISTSTART,SIMPLELIST);
		case 0 : // error
		case 2 : // carry on as you were
			cursor = s->token;
			while (*cursor == ' ' || *cursor == '\t') cursor++;
			DOCB_DB("pre-content whitespace (spaces .)")
			DOCB_RET(DOCB_WHITESPACE,NORMAL)
	  }
	}
#line 1250 "ext/docblock/docblock_scan.c"
yy95:	++YYCURSOR;
	goto yy96;
yy96:
#line 530 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end 3")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 1266 "ext/docblock/docblock_scan.c"
}
}
#line 638 "ext/docblock/docblock_scan.re"

	}
NORMAL:
	if (s->in_internal) {
{
	static unsigned char yybm[] = {
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,   0,  32,  32,   0,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,   0,  32,  32,  32,  32,  32, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160,  32,  32,   0,  32,  32,  32, 
	 32, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224,  32,  32,  32,  32, 160, 
	 32, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224,   0,  32,   0,  32, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	};

#line 1310 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy97;
	++YYCURSOR;
yy97:
	if((YYLIMIT - YYCURSOR) < 7) YYFILL(7);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 32) {
		goto yy107;
	}
	if(yych <= ';'){
		if(yych <= 0x0C)	goto yy104;
		if(yych <= 0x0D)	goto yy106;
		goto yy99;
	} else {
		if(yych <= '<')	goto yy103;
		if(yych <= '|')	goto yy102;
		goto yy101;
	}
yy99:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy220;
	goto yy100;
yy100:
#line 766 "ext/docblock/docblock_scan.re"
{ DOCB_DB("normal text")
		DOCB_BEGINT(DOCB_TEXT,NORMAL);
		}
#line 1339 "ext/docblock/docblock_scan.c"
yy101:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy218;
	goto yy100;
yy102:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '@')	goto yy208;
	goto yy100;
yy103:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych){
	case '/':	goto yy111;
	case '<':	goto yy121;
	case 'B':	case 'b':	goto yy109;
	case 'C':	case 'c':	goto yy120;
	case 'I':	case 'i':	goto yy115;
	case 'K':	case 'k':	goto yy118;
	case 'L':	case 'l':	goto yy112;
	case 'O':	case 'o':	goto yy114;
	case 'P':	case 'p':	goto yy116;
	case 'S':	case 's':	goto yy119;
	case 'U':	case 'u':	goto yy113;
	case 'V':	case 'v':	goto yy117;
	default:	goto yy100;
	}
yy104:	++YYCURSOR;
	goto yy105;
yy105:
#line 762 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (INTERNAL)")
		DOCB_RET(DOCB_NEWLINE,LINESTART);
		}
#line 1371 "ext/docblock/docblock_scan.c"
yy106:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy104;
	goto yy105;
yy107:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy108;
yy108:	if(yybm[0+yych] & 32) {
		goto yy107;
	}
	goto yy100;
yy109:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == '>')	goto yy200;
		goto yy110;
	} else {
		if(yych <= 'R')	goto yy202;
		if(yych == 'r')	goto yy202;
		goto yy110;
	}
yy110:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 1:	goto yy214;
	case 0:	goto yy100;
	}
yy111:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy167;
	case 'I':	case 'i':	goto yy168;
	case 'K':	case 'k':	goto yy164;
	case 'L':	case 'l':	goto yy171;
	case 'O':	case 'o':	goto yy169;
	case 'P':	case 'p':	goto yy166;
	case 'S':	case 's':	goto yy163;
	case 'U':	case 'u':	goto yy170;
	case 'V':	case 'v':	goto yy165;
	default:	goto yy110;
	}
yy112:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy160;
	if(yych == 'i')	goto yy160;
	goto yy110;
yy113:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy157;
	if(yych == 'l')	goto yy157;
	goto yy110;
yy114:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy154;
	if(yych == 'l')	goto yy154;
	goto yy110;
yy115:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy152;
	goto yy110;
yy116:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == '>')	goto yy147;
		goto yy110;
	} else {
		if(yych <= 'R')	goto yy146;
		if(yych == 'r')	goto yy146;
		goto yy110;
	}
yy117:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy142;
	if(yych == 'a')	goto yy142;
	goto yy110;
yy118:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy138;
	if(yych == 'b')	goto yy138;
	goto yy110;
yy119:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy133;
	if(yych == 'a')	goto yy133;
	goto yy110;
yy120:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy128;
	if(yych == 'o')	goto yy128;
	goto yy110;
yy121:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy122;
	if(yych == '>')	goto yy110;
	goto yy124;
yy122:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy110;
	goto yy124;
yy123:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy124;
yy124:	if(yybm[0+yych] & 64) {
		goto yy123;
	}
	if(yych != '>')	goto yy110;
	goto yy125;
yy125:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy126;
yy126:	++YYCURSOR;
	goto yy127;
yy127:
#line 672 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped html tag")
		DOCB_RET(DOCB_ESCAPEDHTML,NORMAL);
		}
#line 1476 "ext/docblock/docblock_scan.c"
yy128:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy129;
	if(yych != 'd')	goto yy110;
	goto yy129;
yy129:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy130;
	if(yych != 'e')	goto yy110;
	goto yy130;
yy130:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy131;
yy131:	++YYCURSOR;
	goto yy132;
yy132:
#line 676 "ext/docblock/docblock_scan.re"
{ DOCB_DB("code section begin")
		s->in_code = 1;
		DOCB_RET(DOCB_CODEOPEN,CODE);
		}
#line 1496 "ext/docblock/docblock_scan.c"
yy133:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy134;
	if(yych != 'm')	goto yy110;
	goto yy134;
yy134:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy135;
	if(yych != 'p')	goto yy110;
	goto yy135;
yy135:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy136;
yy136:	++YYCURSOR;
	goto yy137;
yy137:
#line 686 "ext/docblock/docblock_scan.re"
{ DOCB_DB("samp open")
		DOCB_RET(DOCB_SAMPOPEN,NORMAL);
		}
#line 1515 "ext/docblock/docblock_scan.c"
yy138:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy139;
	if(yych != 'd')	goto yy110;
	goto yy139;
yy139:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy140;
yy140:	++YYCURSOR;
	goto yy141;
yy141:
#line 690 "ext/docblock/docblock_scan.re"
{ DOCB_DB("kbd open")
		DOCB_RET(DOCB_KBDOPEN,NORMAL);
		}
#line 1530 "ext/docblock/docblock_scan.c"
yy142:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy143;
	if(yych != 'r')	goto yy110;
	goto yy143;
yy143:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy144;
yy144:	++YYCURSOR;
	goto yy145;
yy145:
#line 694 "ext/docblock/docblock_scan.re"
{ DOCB_DB("var open")
		DOCB_RET(DOCB_VAROPEN,NORMAL);
		}
#line 1545 "ext/docblock/docblock_scan.c"
yy146:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy149;
	if(yych == 'e')	goto yy149;
	goto yy110;
yy147:	++YYCURSOR;
	goto yy148;
yy148:
#line 698 "ext/docblock/docblock_scan.re"
{ DOCB_DB("p open")
		DOCB_RET(DOCB_POPEN,NORMAL);
		}
#line 1557 "ext/docblock/docblock_scan.c"
yy149:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy150;
yy150:	++YYCURSOR;
	goto yy151;
yy151:
#line 681 "ext/docblock/docblock_scan.re"
{ DOCB_DB("pre section begin")
		s->in_pre = 1;
		DOCB_RET(DOCB_PREOPEN,PRE);
		}
#line 1569 "ext/docblock/docblock_scan.c"
yy152:	++YYCURSOR;
	goto yy153;
yy153:
#line 706 "ext/docblock/docblock_scan.re"
{ DOCB_DB("i open")
		DOCB_RET(DOCB_IOPEN,NORMAL);
		}
#line 1577 "ext/docblock/docblock_scan.c"
yy154:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy155;
yy155:	++YYCURSOR;
	goto yy156;
yy156:
#line 710 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ol open")
		DOCB_RET(DOCB_OLOPEN,NORMAL);
		}
#line 1588 "ext/docblock/docblock_scan.c"
yy157:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy158;
yy158:	++YYCURSOR;
	goto yy159;
yy159:
#line 714 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ul open")
		DOCB_RET(DOCB_ULOPEN,NORMAL);
		}
#line 1599 "ext/docblock/docblock_scan.c"
yy160:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy161;
yy161:	++YYCURSOR;
	goto yy162;
yy162:
#line 718 "ext/docblock/docblock_scan.re"
{ DOCB_DB("li open")
		DOCB_RET(DOCB_LIOPEN,NORMAL);
		}
#line 1610 "ext/docblock/docblock_scan.c"
yy163:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy195;
	if(yych == 'a')	goto yy195;
	goto yy110;
yy164:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy191;
	if(yych == 'b')	goto yy191;
	goto yy110;
yy165:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy187;
	if(yych == 'a')	goto yy187;
	goto yy110;
yy166:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy185;
	goto yy110;
yy167:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy183;
	goto yy110;
yy168:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy181;
	goto yy110;
yy169:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy178;
	if(yych == 'l')	goto yy178;
	goto yy110;
yy170:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy175;
	if(yych == 'l')	goto yy175;
	goto yy110;
yy171:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy172;
	if(yych != 'i')	goto yy110;
	goto yy172;
yy172:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy173;
yy173:	++YYCURSOR;
	goto yy174;
yy174:
#line 754 "ext/docblock/docblock_scan.re"
{ DOCB_DB("li close")
		DOCB_RET(DOCB_LICLOSE,NORMAL);
		}
#line 1654 "ext/docblock/docblock_scan.c"
yy175:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy176;
yy176:	++YYCURSOR;
	goto yy177;
yy177:
#line 750 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ul close")
		DOCB_RET(DOCB_ULCLOSE,NORMAL);
		}
#line 1665 "ext/docblock/docblock_scan.c"
yy178:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy179;
yy179:	++YYCURSOR;
	goto yy180;
yy180:
#line 746 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ol close")
		DOCB_RET(DOCB_OLCLOSE,NORMAL);
		}
#line 1676 "ext/docblock/docblock_scan.c"
yy181:	++YYCURSOR;
	goto yy182;
yy182:
#line 742 "ext/docblock/docblock_scan.re"
{ DOCB_DB("i close")
		DOCB_RET(DOCB_ICLOSE,NORMAL);
		}
#line 1684 "ext/docblock/docblock_scan.c"
yy183:	++YYCURSOR;
	goto yy184;
yy184:
#line 738 "ext/docblock/docblock_scan.re"
{ DOCB_DB("b close")
		DOCB_RET(DOCB_BCLOSE,NORMAL);
		}
#line 1692 "ext/docblock/docblock_scan.c"
yy185:	++YYCURSOR;
	goto yy186;
yy186:
#line 734 "ext/docblock/docblock_scan.re"
{ DOCB_DB("p close")
		DOCB_RET(DOCB_PCLOSE,NORMAL);
		}
#line 1700 "ext/docblock/docblock_scan.c"
yy187:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy188;
	if(yych != 'r')	goto yy110;
	goto yy188;
yy188:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy189;
yy189:	++YYCURSOR;
	goto yy190;
yy190:
#line 730 "ext/docblock/docblock_scan.re"
{ DOCB_DB("var close")
		DOCB_RET(DOCB_VARCLOSE,NORMAL);
		}
#line 1715 "ext/docblock/docblock_scan.c"
yy191:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy192;
	if(yych != 'd')	goto yy110;
	goto yy192;
yy192:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy193;
yy193:	++YYCURSOR;
	goto yy194;
yy194:
#line 726 "ext/docblock/docblock_scan.re"
{ DOCB_DB("kbd close")
		DOCB_RET(DOCB_KBDCLOSE,NORMAL);
		}
#line 1730 "ext/docblock/docblock_scan.c"
yy195:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy196;
	if(yych != 'm')	goto yy110;
	goto yy196;
yy196:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy197;
	if(yych != 'p')	goto yy110;
	goto yy197;
yy197:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy198;
yy198:	++YYCURSOR;
	goto yy199;
yy199:
#line 722 "ext/docblock/docblock_scan.re"
{ DOCB_DB("samp close")
		DOCB_RET(DOCB_SAMPCLOSE,NORMAL);
		}
#line 1749 "ext/docblock/docblock_scan.c"
yy200:	++YYCURSOR;
	goto yy201;
yy201:
#line 702 "ext/docblock/docblock_scan.re"
{ DOCB_DB("b open")
		DOCB_RET(DOCB_BOPEN,NORMAL);
		}
#line 1757 "ext/docblock/docblock_scan.c"
yy202:	yych = *++YYCURSOR;
	if(yych <= '.'){
		if(yych != ' ')	goto yy110;
		goto yy203;
	} else {
		if(yych <= '/')	goto yy204;
		if(yych == '>')	goto yy205;
		goto yy110;
	}
yy203:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy207;
	goto yy110;
yy204:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy110;
	goto yy205;
yy205:	++YYCURSOR;
	goto yy206;
yy206:
#line 758 "ext/docblock/docblock_scan.re"
{ DOCB_DB("br tag")
		DOCB_RET(DOCB_BR,NORMAL);
		}
#line 1780 "ext/docblock/docblock_scan.c"
yy207:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy205;
	goto yy110;
yy208:	yych = *++YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@'){
			if(yych == '*')	goto yy211;
			goto yy110;
		} else {
			if(yych <= 'Z')	goto yy212;
			if(yych <= '^')	goto yy110;
			goto yy212;
		}
	} else {
		if(yych <= '|'){
			if(yych <= '`')	goto yy110;
			if(yych <= 'z')	goto yy212;
			goto yy110;
		} else {
			if(yych <= '}')	goto yy209;
			if(yych <= '~')	goto yy110;
			goto yy212;
		}
	}
yy209:	++YYCURSOR;
	goto yy210;
yy210:
#line 663 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped inline tag")
		DOCB_RET(DOCB_ESCAPEDINLINETAG,NORMAL);
		}
#line 1812 "ext/docblock/docblock_scan.c"
yy211:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy209;
	goto yy110;
yy212:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy213;
yy213:	if(yybm[0+yych] & 128) {
		goto yy212;
	}
	if(yych == '.')	goto yy215;
	goto yy214;
yy214:
#line 667 "ext/docblock/docblock_scan.re"
{ DOCB_DB("inline tag start")
		s->in_inlinetag = 1;
		DOCB_RET(DOCB_INLINETAG,INLINETAG);
		}
#line 1832 "ext/docblock/docblock_scan.c"
yy215:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy110;
		if(yych <= 'Z')	goto yy216;
		if(yych <= '^')	goto yy110;
		goto yy216;
	} else {
		if(yych <= '`')	goto yy110;
		if(yych <= 'z')	goto yy216;
		if(yych <= '~')	goto yy110;
		goto yy216;
	}
yy216:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy217;
yy217:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy215;
			goto yy214;
		} else {
			if(yych <= '9')	goto yy216;
			if(yych <= '@')	goto yy214;
			goto yy216;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy216;
			goto yy214;
		} else {
			if(yych <= 'z')	goto yy216;
			if(yych <= '~')	goto yy214;
			goto yy216;
		}
	}
yy218:	++YYCURSOR;
	goto yy219;
yy219:
#line 655 "ext/docblock/docblock_scan.re"
{ DOCB_DB("end internal")
		// if normalcursor is set, this will be re-scanned
		if (!s->normalcursor) {
			s->in_internal = 0;
		}
		DOCB_RET(DOCB_ENDINTERNAL,NORMAL);
		}
#line 1882 "ext/docblock/docblock_scan.c"
yy220:	++YYCURSOR;
	goto yy221;
yy221:
#line 643 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
			if (!s->return_simplelist_end) {
				zend_llist_remove_tail(s->simplelist);
			}
			cursor = s->token; // empty token
			DOCB_DB("simplelist end n1")
			DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
		}
		DOCB_DB("end comment")
		DOCB_RET(DOCB_COMMENTEND,LINESTART);
		}
#line 1898 "ext/docblock/docblock_scan.c"
}
}
#line 769 "ext/docblock/docblock_scan.re"

	} // if (s->in_internal)
//NORMAL_TEXT:
{
	static unsigned char yybm[] = {
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,   0,  32,  32,   0,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,  32,  32,  32,  32,  32,  32, 
	 32,  32,   0,  32,  32,  32,  32,  32, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160,  32,  32,   0,  32,  32,  32, 
	 32, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224,  32,  32,  32,  32, 160, 
	 32, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224, 224, 224, 224, 224, 224, 
	224, 224, 224,   0,  32,  32,  32, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	160, 160, 160, 160, 160, 160, 160, 160, 
	};

#line 1941 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy222;
	++YYCURSOR;
yy222:
	if((YYLIMIT - YYCURSOR) < 11) YYFILL(11);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 32) {
		goto yy231;
	}
	if(yych <= 0x0C)	goto yy228;
	if(yych <= 0x0D)	goto yy230;
	if(yych <= ';')	goto yy224;
	if(yych <= '<')	goto yy227;
	goto yy226;
yy224:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy351;
	goto yy225;
yy225:
#line 893 "ext/docblock/docblock_scan.re"
{ DOCB_DB("normal text")
	  DOCB_BEGINT(DOCB_TEXT,NORMAL);
	}
#line 1966 "ext/docblock/docblock_scan.c"
yy226:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '@')	goto yy332;
	goto yy225;
yy227:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	switch(yych){
	case '/':	goto yy235;
	case '<':	goto yy245;
	case 'B':	case 'b':	goto yy233;
	case 'C':	case 'c':	goto yy244;
	case 'I':	case 'i':	goto yy239;
	case 'K':	case 'k':	goto yy242;
	case 'L':	case 'l':	goto yy236;
	case 'O':	case 'o':	goto yy238;
	case 'P':	case 'p':	goto yy240;
	case 'S':	case 's':	goto yy243;
	case 'U':	case 'u':	goto yy237;
	case 'V':	case 'v':	goto yy241;
	default:	goto yy225;
	}
yy228:	++YYCURSOR;
	goto yy229;
yy229:
#line 889 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (NORMAL)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 1995 "ext/docblock/docblock_scan.c"
yy230:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy228;
	goto yy229;
yy231:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy232;
yy232:	if(yybm[0+yych] & 32) {
		goto yy231;
	}
	goto yy225;
yy233:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == '>')	goto yy324;
		goto yy234;
	} else {
		if(yych <= 'R')	goto yy326;
		if(yych == 'r')	goto yy326;
		goto yy234;
	}
yy234:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 2:	goto yy350;
	case 1:	goto yy334;
	case 0:	goto yy225;
	}
yy235:	yych = *++YYCURSOR;
	switch(yych){
	case 'B':	case 'b':	goto yy291;
	case 'I':	case 'i':	goto yy292;
	case 'K':	case 'k':	goto yy288;
	case 'L':	case 'l':	goto yy295;
	case 'O':	case 'o':	goto yy293;
	case 'P':	case 'p':	goto yy290;
	case 'S':	case 's':	goto yy287;
	case 'U':	case 'u':	goto yy294;
	case 'V':	case 'v':	goto yy289;
	default:	goto yy234;
	}
yy236:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy284;
	if(yych == 'i')	goto yy284;
	goto yy234;
yy237:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy281;
	if(yych == 'l')	goto yy281;
	goto yy234;
yy238:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy278;
	if(yych == 'l')	goto yy278;
	goto yy234;
yy239:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy276;
	goto yy234;
yy240:	yych = *++YYCURSOR;
	if(yych <= 'Q'){
		if(yych == '>')	goto yy271;
		goto yy234;
	} else {
		if(yych <= 'R')	goto yy270;
		if(yych == 'r')	goto yy270;
		goto yy234;
	}
yy241:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy266;
	if(yych == 'a')	goto yy266;
	goto yy234;
yy242:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy262;
	if(yych == 'b')	goto yy262;
	goto yy234;
yy243:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy257;
	if(yych == 'a')	goto yy257;
	goto yy234;
yy244:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy252;
	if(yych == 'o')	goto yy252;
	goto yy234;
yy245:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy246;
	if(yych == '>')	goto yy234;
	goto yy248;
yy246:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy234;
	goto yy248;
yy247:	++YYCURSOR;
	if((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	goto yy248;
yy248:	if(yybm[0+yych] & 64) {
		goto yy247;
	}
	if(yych != '>')	goto yy234;
	goto yy249;
yy249:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy250;
yy250:	++YYCURSOR;
	goto yy251;
yy251:
#line 799 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped html tag")
	  DOCB_RET(DOCB_ESCAPEDHTML,NORMAL);
	}
#line 2101 "ext/docblock/docblock_scan.c"
yy252:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy253;
	if(yych != 'd')	goto yy234;
	goto yy253;
yy253:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy254;
	if(yych != 'e')	goto yy234;
	goto yy254;
yy254:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy255;
yy255:	++YYCURSOR;
	goto yy256;
yy256:
#line 803 "ext/docblock/docblock_scan.re"
{ DOCB_DB("code section begin")
	  s->in_code = 1;
	  DOCB_RET(DOCB_CODEOPEN,CODE);
	}
#line 2121 "ext/docblock/docblock_scan.c"
yy257:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy258;
	if(yych != 'm')	goto yy234;
	goto yy258;
yy258:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy259;
	if(yych != 'p')	goto yy234;
	goto yy259;
yy259:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy260;
yy260:	++YYCURSOR;
	goto yy261;
yy261:
#line 813 "ext/docblock/docblock_scan.re"
{ DOCB_DB("samp open")
	  DOCB_RET(DOCB_SAMPOPEN,NORMAL);
	}
#line 2140 "ext/docblock/docblock_scan.c"
yy262:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy263;
	if(yych != 'd')	goto yy234;
	goto yy263;
yy263:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy264;
yy264:	++YYCURSOR;
	goto yy265;
yy265:
#line 817 "ext/docblock/docblock_scan.re"
{ DOCB_DB("kbd open")
	  DOCB_RET(DOCB_KBDOPEN,NORMAL);
	}
#line 2155 "ext/docblock/docblock_scan.c"
yy266:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy267;
	if(yych != 'r')	goto yy234;
	goto yy267;
yy267:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy268;
yy268:	++YYCURSOR;
	goto yy269;
yy269:
#line 821 "ext/docblock/docblock_scan.re"
{ DOCB_DB("var open")
	  DOCB_RET(DOCB_VAROPEN,NORMAL);
	}
#line 2170 "ext/docblock/docblock_scan.c"
yy270:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy273;
	if(yych == 'e')	goto yy273;
	goto yy234;
yy271:	++YYCURSOR;
	goto yy272;
yy272:
#line 825 "ext/docblock/docblock_scan.re"
{ DOCB_DB("p open")
	  DOCB_RET(DOCB_POPEN,NORMAL);
	}
#line 2182 "ext/docblock/docblock_scan.c"
yy273:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy274;
yy274:	++YYCURSOR;
	goto yy275;
yy275:
#line 808 "ext/docblock/docblock_scan.re"
{ DOCB_DB("pre section begin")
	  s->in_pre = 1;
	  DOCB_RET(DOCB_PREOPEN,PRE);
	}
#line 2194 "ext/docblock/docblock_scan.c"
yy276:	++YYCURSOR;
	goto yy277;
yy277:
#line 833 "ext/docblock/docblock_scan.re"
{ DOCB_DB("i open")
	  DOCB_RET(DOCB_IOPEN,NORMAL);
	}
#line 2202 "ext/docblock/docblock_scan.c"
yy278:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy279;
yy279:	++YYCURSOR;
	goto yy280;
yy280:
#line 837 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ol open")
	  DOCB_RET(DOCB_OLOPEN,NORMAL);
	}
#line 2213 "ext/docblock/docblock_scan.c"
yy281:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy282;
yy282:	++YYCURSOR;
	goto yy283;
yy283:
#line 841 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ul open")
	  DOCB_RET(DOCB_ULOPEN,NORMAL);
	}
#line 2224 "ext/docblock/docblock_scan.c"
yy284:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy285;
yy285:	++YYCURSOR;
	goto yy286;
yy286:
#line 845 "ext/docblock/docblock_scan.re"
{ DOCB_DB("li open")
	  DOCB_RET(DOCB_LIOPEN,NORMAL);
	}
#line 2235 "ext/docblock/docblock_scan.c"
yy287:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy319;
	if(yych == 'a')	goto yy319;
	goto yy234;
yy288:	yych = *++YYCURSOR;
	if(yych == 'B')	goto yy315;
	if(yych == 'b')	goto yy315;
	goto yy234;
yy289:	yych = *++YYCURSOR;
	if(yych == 'A')	goto yy311;
	if(yych == 'a')	goto yy311;
	goto yy234;
yy290:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy309;
	goto yy234;
yy291:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy307;
	goto yy234;
yy292:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy305;
	goto yy234;
yy293:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy302;
	if(yych == 'l')	goto yy302;
	goto yy234;
yy294:	yych = *++YYCURSOR;
	if(yych == 'L')	goto yy299;
	if(yych == 'l')	goto yy299;
	goto yy234;
yy295:	yych = *++YYCURSOR;
	if(yych == 'I')	goto yy296;
	if(yych != 'i')	goto yy234;
	goto yy296;
yy296:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy297;
yy297:	++YYCURSOR;
	goto yy298;
yy298:
#line 881 "ext/docblock/docblock_scan.re"
{ DOCB_DB("li close")
	  DOCB_RET(DOCB_LICLOSE,NORMAL);
	}
#line 2279 "ext/docblock/docblock_scan.c"
yy299:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy300;
yy300:	++YYCURSOR;
	goto yy301;
yy301:
#line 877 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ul close")
	  DOCB_RET(DOCB_ULCLOSE,NORMAL);
	}
#line 2290 "ext/docblock/docblock_scan.c"
yy302:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy303;
yy303:	++YYCURSOR;
	goto yy304;
yy304:
#line 873 "ext/docblock/docblock_scan.re"
{ DOCB_DB("ol close")
	  DOCB_RET(DOCB_OLCLOSE,NORMAL);
	}
#line 2301 "ext/docblock/docblock_scan.c"
yy305:	++YYCURSOR;
	goto yy306;
yy306:
#line 869 "ext/docblock/docblock_scan.re"
{ DOCB_DB("i close")
	  DOCB_RET(DOCB_ICLOSE,NORMAL);
	}
#line 2309 "ext/docblock/docblock_scan.c"
yy307:	++YYCURSOR;
	goto yy308;
yy308:
#line 865 "ext/docblock/docblock_scan.re"
{ DOCB_DB("b close")
	  DOCB_RET(DOCB_BCLOSE,NORMAL);
	}
#line 2317 "ext/docblock/docblock_scan.c"
yy309:	++YYCURSOR;
	goto yy310;
yy310:
#line 861 "ext/docblock/docblock_scan.re"
{ DOCB_DB("p close")
	  DOCB_RET(DOCB_PCLOSE,NORMAL);
	}
#line 2325 "ext/docblock/docblock_scan.c"
yy311:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy312;
	if(yych != 'r')	goto yy234;
	goto yy312;
yy312:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy313;
yy313:	++YYCURSOR;
	goto yy314;
yy314:
#line 857 "ext/docblock/docblock_scan.re"
{ DOCB_DB("var close")
	  DOCB_RET(DOCB_VARCLOSE,NORMAL);
	}
#line 2340 "ext/docblock/docblock_scan.c"
yy315:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy316;
	if(yych != 'd')	goto yy234;
	goto yy316;
yy316:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy317;
yy317:	++YYCURSOR;
	goto yy318;
yy318:
#line 853 "ext/docblock/docblock_scan.re"
{ DOCB_DB("kbd close")
	  DOCB_RET(DOCB_KBDCLOSE,NORMAL);
	}
#line 2355 "ext/docblock/docblock_scan.c"
yy319:	yych = *++YYCURSOR;
	if(yych == 'M')	goto yy320;
	if(yych != 'm')	goto yy234;
	goto yy320;
yy320:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy321;
	if(yych != 'p')	goto yy234;
	goto yy321;
yy321:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy322;
yy322:	++YYCURSOR;
	goto yy323;
yy323:
#line 849 "ext/docblock/docblock_scan.re"
{ DOCB_DB("samp close")
	  DOCB_RET(DOCB_SAMPCLOSE,NORMAL);
	}
#line 2374 "ext/docblock/docblock_scan.c"
yy324:	++YYCURSOR;
	goto yy325;
yy325:
#line 829 "ext/docblock/docblock_scan.re"
{ DOCB_DB("b open")
	  DOCB_RET(DOCB_BOPEN,NORMAL);
	}
#line 2382 "ext/docblock/docblock_scan.c"
yy326:	yych = *++YYCURSOR;
	if(yych <= '.'){
		if(yych != ' ')	goto yy234;
		goto yy327;
	} else {
		if(yych <= '/')	goto yy328;
		if(yych == '>')	goto yy329;
		goto yy234;
	}
yy327:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy331;
	goto yy234;
yy328:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy234;
	goto yy329;
yy329:	++YYCURSOR;
	goto yy330;
yy330:
#line 885 "ext/docblock/docblock_scan.re"
{ DOCB_DB("br tag")
	  DOCB_RET(DOCB_BR,NORMAL);
	}
#line 2405 "ext/docblock/docblock_scan.c"
yy331:	yych = *++YYCURSOR;
	if(yych == '>')	goto yy329;
	goto yy234;
yy332:	yych = *++YYCURSOR;
	if(yych <= '`'){
		if(yych <= '@'){
			if(yych == '*')	goto yy337;
			goto yy234;
		} else {
			if(yych <= 'Z')	goto yy338;
			if(yych == '_')	goto yy338;
			goto yy234;
		}
	} else {
		if(yych <= 'z'){
			if(yych != 'i')	goto yy338;
			goto yy333;
		} else {
			if(yych == '}')	goto yy335;
			if(yych <= '~')	goto yy234;
			goto yy338;
		}
	}
yy333:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == 'n')	goto yy343;
	goto yy339;
yy334:
#line 794 "ext/docblock/docblock_scan.re"
{ DOCB_DB("inline tag start")
	  s->in_inlinetag = 1;
	  DOCB_RET(DOCB_INLINETAG,INLINETAG);
	}
#line 2439 "ext/docblock/docblock_scan.c"
yy335:	++YYCURSOR;
	goto yy336;
yy336:
#line 790 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped inline tag")
	  DOCB_RET(DOCB_ESCAPEDINLINETAG,NORMAL);
	}
#line 2447 "ext/docblock/docblock_scan.c"
yy337:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy335;
	goto yy234;
yy338:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy339;
yy339:	if(yybm[0+yych] & 128) {
		goto yy338;
	}
	if(yych != '.')	goto yy334;
	goto yy340;
yy340:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy234;
		if(yych <= 'Z')	goto yy341;
		if(yych <= '^')	goto yy234;
		goto yy341;
	} else {
		if(yych <= '`')	goto yy234;
		if(yych <= 'z')	goto yy341;
		if(yych <= '~')	goto yy234;
		goto yy341;
	}
yy341:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy342;
yy342:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy340;
			goto yy334;
		} else {
			if(yych <= '9')	goto yy341;
			if(yych <= '@')	goto yy334;
			goto yy341;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy341;
			goto yy334;
		} else {
			if(yych <= 'z')	goto yy341;
			if(yych <= '~')	goto yy334;
			goto yy341;
		}
	}
yy343:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 't')	goto yy339;
	goto yy344;
yy344:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 'e')	goto yy339;
	goto yy345;
yy345:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 'r')	goto yy339;
	goto yy346;
yy346:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 'n')	goto yy339;
	goto yy347;
yy347:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 'a')	goto yy339;
	goto yy348;
yy348:	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych != 'l')	goto yy339;
	goto yy349;
yy349:	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yybm[0+yych] & 128) {
		goto yy338;
	}
	if(yych == '.')	goto yy340;
	goto yy350;
yy350:
#line 785 "ext/docblock/docblock_scan.re"
{ DOCB_DB("internal start")
	  s->in_internal = 1;
	  DOCB_RET(DOCB_INTERNAL,NORMAL);
	}
#line 2536 "ext/docblock/docblock_scan.c"
yy351:	++YYCURSOR;
	goto yy352;
yy352:
#line 773 "ext/docblock/docblock_scan.re"
{ if (s->simplelist->count) {
		if (!s->return_simplelist_end) {
			zend_llist_remove_tail(s->simplelist);
		}
		cursor = s->token; // empty token
		DOCB_DB("simplelist end n2")
		DOCB_RET(DOCB_SIMPLELISTEND,POSTASTERISK);
	  }
	  DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 2552 "ext/docblock/docblock_scan.c"
}
}
#line 896 "ext/docblock/docblock_scan.re"

INLINETAG:
{
	static unsigned char yybm[] = {
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128,   0, 128, 128,   0, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128,   0, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128,   0, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	128, 128, 128, 128, 128, 128, 128, 128, 
	};

#line 2594 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	goto yy353;
	++YYCURSOR;
yy353:
	if((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if(yych <= ')'){
		if(yych <= 0x0A){
			if(yych <= 0x09)	goto yy360;
			goto yy363;
		} else {
			if(yych == 0x0D)	goto yy362;
			goto yy360;
		}
	} else {
		if(yych <= '\\'){
			if(yych <= '*')	goto yy355;
			if(yych <= '[')	goto yy360;
			goto yy357;
		} else {
			if(yych == '}')	goto yy358;
			goto yy360;
		}
	}
yy355:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy367;
	goto yy361;
yy356:
#line 913 "ext/docblock/docblock_scan.re"
{ DOCB_DB("inline tag contents")
	  DOCB_BEGINT(DOCB_INLINETAGCONTENTS,INLINETAG);
	}
#line 2628 "ext/docblock/docblock_scan.c"
yy357:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy365;
	goto yy356;
yy358:	++YYCURSOR;
	goto yy359;
yy359:
#line 905 "ext/docblock/docblock_scan.re"
{ DOCB_DB("end inline tag")
	  // if normalcursor is set, this will be re-scanned
	  if (!s->normalcursor) {
		s->in_inlinetag = 0;
	  }
	  DOCB_RET(DOCB_ENDINLINETAG,NORMAL);
	}
#line 2643 "ext/docblock/docblock_scan.c"
yy360:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy361;
yy361:	if(yybm[0+yych] & 128) {
		goto yy360;
	}
	goto yy356;
yy362:	yych = *++YYCURSOR;
	if(yych != 0x0A)	goto yy356;
	goto yy363;
yy363:	++YYCURSOR;
	goto yy364;
yy364:
#line 917 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (INLINETAG)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 2662 "ext/docblock/docblock_scan.c"
yy365:	++YYCURSOR;
	goto yy366;
yy366:
#line 902 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped end inline tag")
	  DOCB_RET(DOCB_ESCAPEDINLINEEND,INLINETAG);
	}
#line 2670 "ext/docblock/docblock_scan.c"
yy367:	++YYCURSOR;
	if(yybm[0+(yych = *YYCURSOR)] & 128) {
		yych = *YYCURSOR;
		goto yy360;
	}
	goto yy368;
yy368:
#line 899 "ext/docblock/docblock_scan.re"
{ DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 2682 "ext/docblock/docblock_scan.c"
}
}
#line 920 "ext/docblock/docblock_scan.re"

CODE:
{
	static unsigned char yybm[] = {
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,   0,  64,  64,   0,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,   0,  64,  64,  64,  64,  64, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192,  64,  64,   0,  64,  64,  64, 
	 64, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192,  64,  64,  64,  64, 192, 
	 64, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192,   0,  64,  64,  64, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	};

#line 2724 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy369;
	++YYCURSOR;
yy369:
	if((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 64) {
		goto yy378;
	}
	if(yych <= 0x0C)	goto yy374;
	if(yych <= 0x0D)	goto yy376;
	if(yych <= ';')	goto yy371;
	if(yych <= '<')	goto yy373;
	goto yy377;
yy371:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy407;
	goto yy372;
yy372:
#line 952 "ext/docblock/docblock_scan.re"
{ DOCB_DB("normal text")
	  DOCB_BEGINT(DOCB_TEXT,CODE);
	}
#line 2749 "ext/docblock/docblock_scan.c"
yy373:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '/')	goto yy392;
	if(yych == '<')	goto yy391;
	goto yy372;
yy374:	++YYCURSOR;
	goto yy375;
yy375:
#line 935 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (CODE)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 2762 "ext/docblock/docblock_scan.c"
yy376:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy374;
	goto yy375;
yy377:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '@')	goto yy380;
	goto yy372;
yy378:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy379;
yy379:	if(yybm[0+yych] & 64) {
		goto yy378;
	}
	goto yy372;
yy380:	yych = *++YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@'){
			if(yych == '*')	goto yy384;
			goto yy381;
		} else {
			if(yych <= 'Z')	goto yy385;
			if(yych >= '_')	goto yy385;
			goto yy381;
		}
	} else {
		if(yych <= '|'){
			if(yych <= '`')	goto yy381;
			if(yych <= 'z')	goto yy385;
			goto yy381;
		} else {
			if(yych <= '}')	goto yy382;
			if(yych >= 0x7F)	goto yy385;
			goto yy381;
		}
	}
yy381:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 1:	goto yy387;
	case 0:	goto yy372;
	}
yy382:	++YYCURSOR;
	goto yy383;
yy383:
#line 939 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped inline tag")
	  DOCB_RET(DOCB_ESCAPEDINLINETAG,CODE);
	}
#line 2811 "ext/docblock/docblock_scan.c"
yy384:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy382;
	goto yy381;
yy385:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy386;
yy386:	if(yybm[0+yych] & 128) {
		goto yy385;
	}
	if(yych == '.')	goto yy388;
	goto yy387;
yy387:
#line 943 "ext/docblock/docblock_scan.re"
{ DOCB_DB("inline tag start")
	  s->in_inlinetag = 1;
	  DOCB_RET(DOCB_INLINETAG,INLINETAG);
	}
#line 2831 "ext/docblock/docblock_scan.c"
yy388:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy381;
		if(yych <= 'Z')	goto yy389;
		if(yych <= '^')	goto yy381;
		goto yy389;
	} else {
		if(yych <= '`')	goto yy381;
		if(yych <= 'z')	goto yy389;
		if(yych <= '~')	goto yy381;
		goto yy389;
	}
yy389:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy390;
yy390:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy388;
			goto yy387;
		} else {
			if(yych <= '9')	goto yy389;
			if(yych <= '@')	goto yy387;
			goto yy389;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy389;
			goto yy387;
		} else {
			if(yych <= 'z')	goto yy389;
			if(yych <= '~')	goto yy387;
			goto yy389;
		}
	}
yy391:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy399;
	goto yy381;
yy392:	yych = *++YYCURSOR;
	if(yych != 'c')	goto yy381;
	goto yy393;
yy393:	yych = *++YYCURSOR;
	if(yych != 'o')	goto yy381;
	goto yy394;
yy394:	yych = *++YYCURSOR;
	if(yych != 'd')	goto yy381;
	goto yy395;
yy395:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy381;
	goto yy396;
yy396:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy381;
	goto yy397;
yy397:	++YYCURSOR;
	goto yy398;
yy398:
#line 927 "ext/docblock/docblock_scan.re"
{ DOCB_DB("close code")
	  // if normalcursor is set, this will be re-scanned
	  if (!s->normalcursor) {
	  	s->in_code = 0;
	  }
	  DOCB_RET(DOCB_CODECLOSE,NORMAL);
	}
#line 2899 "ext/docblock/docblock_scan.c"
yy399:	yych = *++YYCURSOR;
	if(yych == 'C')	goto yy400;
	if(yych != 'c')	goto yy381;
	goto yy400;
yy400:	yych = *++YYCURSOR;
	if(yych == 'O')	goto yy401;
	if(yych != 'o')	goto yy381;
	goto yy401;
yy401:	yych = *++YYCURSOR;
	if(yych == 'D')	goto yy402;
	if(yych != 'd')	goto yy381;
	goto yy402;
yy402:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy403;
	if(yych != 'e')	goto yy381;
	goto yy403;
yy403:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy381;
	goto yy404;
yy404:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy381;
	goto yy405;
yy405:	++YYCURSOR;
	goto yy406;
yy406:
#line 948 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped html tag")
	  DOCB_RET(DOCB_ESCAPEDHTML,CODE);
	}
#line 2929 "ext/docblock/docblock_scan.c"
yy407:	++YYCURSOR;
	goto yy408;
yy408:
#line 923 "ext/docblock/docblock_scan.re"
{ DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 2937 "ext/docblock/docblock_scan.c"
}
}
#line 955 "ext/docblock/docblock_scan.re"

PRE:
{
	static unsigned char yybm[] = {
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,   0,  64,  64,   0,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,  64,  64,  64,  64,  64,  64, 
	 64,  64,   0,  64,  64,  64,  64,  64, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192,  64,  64,   0,  64,  64,  64, 
	 64, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192,  64,  64,  64,  64, 192, 
	 64, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192,   0,  64,  64,  64, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	192, 192, 192, 192, 192, 192, 192, 192, 
	};

#line 2979 "ext/docblock/docblock_scan.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	goto yy409;
	++YYCURSOR;
yy409:
	if((YYLIMIT - YYCURSOR) < 8) YYFILL(8);
	yych = *YYCURSOR;
	if(yybm[0+yych] & 64) {
		goto yy418;
	}
	if(yych <= 0x0C)	goto yy414;
	if(yych <= 0x0D)	goto yy416;
	if(yych <= ';')	goto yy411;
	if(yych <= '<')	goto yy413;
	goto yy417;
yy411:	++YYCURSOR;
	if((yych = *YYCURSOR) == '/')	goto yy445;
	goto yy412;
yy412:
#line 987 "ext/docblock/docblock_scan.re"
{ DOCB_DB("normal text")
	  DOCB_BEGINT(DOCB_TEXT,PRE);
	}
#line 3004 "ext/docblock/docblock_scan.c"
yy413:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '/')	goto yy432;
	if(yych == '<')	goto yy431;
	goto yy412;
yy414:	++YYCURSOR;
	goto yy415;
yy415:
#line 970 "ext/docblock/docblock_scan.re"
{ DOCB_DB("newline (PRE)")
	  DOCB_RET(DOCB_NEWLINE,LINESTART);
	}
#line 3017 "ext/docblock/docblock_scan.c"
yy416:	yych = *++YYCURSOR;
	if(yych == 0x0A)	goto yy414;
	goto yy415;
yy417:	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if(yych == '@')	goto yy420;
	goto yy412;
yy418:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy419;
yy419:	if(yybm[0+yych] & 64) {
		goto yy418;
	}
	goto yy412;
yy420:	yych = *++YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@'){
			if(yych == '*')	goto yy424;
			goto yy421;
		} else {
			if(yych <= 'Z')	goto yy425;
			if(yych >= '_')	goto yy425;
			goto yy421;
		}
	} else {
		if(yych <= '|'){
			if(yych <= '`')	goto yy421;
			if(yych <= 'z')	goto yy425;
			goto yy421;
		} else {
			if(yych <= '}')	goto yy422;
			if(yych >= 0x7F)	goto yy425;
			goto yy421;
		}
	}
yy421:	YYCURSOR = YYMARKER;
	switch(yyaccept){
	case 1:	goto yy427;
	case 0:	goto yy412;
	}
yy422:	++YYCURSOR;
	goto yy423;
yy423:
#line 974 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped inline tag")
	  DOCB_RET(DOCB_ESCAPEDINLINETAG,PRE);
	}
#line 3066 "ext/docblock/docblock_scan.c"
yy424:	yych = *++YYCURSOR;
	if(yych == '}')	goto yy422;
	goto yy421;
yy425:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy426;
yy426:	if(yybm[0+yych] & 128) {
		goto yy425;
	}
	if(yych == '.')	goto yy428;
	goto yy427;
yy427:
#line 978 "ext/docblock/docblock_scan.re"
{ DOCB_DB("inline tag start")
	  s->in_inlinetag = 1;
	  DOCB_RET(DOCB_INLINETAG,INLINETAG);
	}
#line 3086 "ext/docblock/docblock_scan.c"
yy428:	++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if(yych <= '_'){
		if(yych <= '@')	goto yy421;
		if(yych <= 'Z')	goto yy429;
		if(yych <= '^')	goto yy421;
		goto yy429;
	} else {
		if(yych <= '`')	goto yy421;
		if(yych <= 'z')	goto yy429;
		if(yych <= '~')	goto yy421;
		goto yy429;
	}
yy429:	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if(YYLIMIT == YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	goto yy430;
yy430:	if(yych <= 'Z'){
		if(yych <= '/'){
			if(yych == '.')	goto yy428;
			goto yy427;
		} else {
			if(yych <= '9')	goto yy429;
			if(yych <= '@')	goto yy427;
			goto yy429;
		}
	} else {
		if(yych <= '`'){
			if(yych == '_')	goto yy429;
			goto yy427;
		} else {
			if(yych <= 'z')	goto yy429;
			if(yych <= '~')	goto yy427;
			goto yy429;
		}
	}
yy431:	yych = *++YYCURSOR;
	if(yych == '/')	goto yy438;
	goto yy421;
yy432:	yych = *++YYCURSOR;
	if(yych != 'p')	goto yy421;
	goto yy433;
yy433:	yych = *++YYCURSOR;
	if(yych != 'r')	goto yy421;
	goto yy434;
yy434:	yych = *++YYCURSOR;
	if(yych != 'e')	goto yy421;
	goto yy435;
yy435:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy421;
	goto yy436;
yy436:	++YYCURSOR;
	goto yy437;
yy437:
#line 962 "ext/docblock/docblock_scan.re"
{ DOCB_DB("close pre")
	  // if normalcursor is set, this will be re-scanned
	  if (!s->normalcursor) {
		s->in_pre = 0;
	  }
	  DOCB_RET(DOCB_PRECLOSE,NORMAL);
	}
#line 3151 "ext/docblock/docblock_scan.c"
yy438:	yych = *++YYCURSOR;
	if(yych == 'P')	goto yy439;
	if(yych != 'p')	goto yy421;
	goto yy439;
yy439:	yych = *++YYCURSOR;
	if(yych == 'R')	goto yy440;
	if(yych != 'r')	goto yy421;
	goto yy440;
yy440:	yych = *++YYCURSOR;
	if(yych == 'E')	goto yy441;
	if(yych != 'e')	goto yy421;
	goto yy441;
yy441:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy421;
	goto yy442;
yy442:	yych = *++YYCURSOR;
	if(yych != '>')	goto yy421;
	goto yy443;
yy443:	++YYCURSOR;
	goto yy444;
yy444:
#line 983 "ext/docblock/docblock_scan.re"
{ DOCB_DB("escaped html tag")
	  DOCB_RET(DOCB_ESCAPEDHTML,PRE);
	}
#line 3177 "ext/docblock/docblock_scan.c"
yy445:	++YYCURSOR;
	goto yy446;
yy446:
#line 958 "ext/docblock/docblock_scan.re"
{ DOCB_DB("end comment")
	  DOCB_RET(DOCB_COMMENTEND,LINESTART);
	}
#line 3185 "ext/docblock/docblock_scan.c"
}
}
#line 990 "ext/docblock/docblock_scan.re"

	return 0;
}
